function Rec = reconstructShiftCP(FACT,T)

% Reconstructs the data from FACT obtained from the shiftCP model
% Written by Morten Mrup
noc=size(FACT{1},2);
nrmodes=length(FACT);
krprt = ones(1,noc);
for k = 3:nrmodes
    krprt = krprod(FACT{k},krprt);
end
for k=1:nrmodes
    N(k)=size(FACT{k},1);
end
if nrmodes<3
    N(3)=1;
end

Ns = N(2);
f = -1i*2*pi*(0:Ns-1)/Ns;
Nf=floor(length(f)/2)+1;
Sf = fft(FACT{2}',[],2);
Sf = Sf(:,1:Nf);
f = f(1:Nf);

Rec=zeros(N(1:3));

for i = 1:N(1)
   Sft = Sf.*exp(T(i,:)'*f); 
   if mod(N(2),2) == 0
       Sft = [Sft conj(Sft(:,end-1:-1:2))];
   else
       Sft = [Sft conj(Sft(:,end:-1:2))];
   end
   St = real(ifft(Sft,[],2));
   Rec(i,:,:) = St'*krprod(FACT{1}(i,:),krprt)';
end
